//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Params.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TParamsForm *ParamsForm;
//---------------------------------------------------------------------------
__fastcall TParamsForm::TParamsForm(TComponent* Owner)
    : TForm(Owner)
{
    // initialisation
    ActiveControl = BtnOk;
    DialogResult = false;
    // prpare le bitmap associ pour rcuprer la slection
    Image.piWidth = GetSelWidth();
    Image.piHeight = GetSelHeight();
    CreateDBmp(&Image);
}
//---------------------------------------------------------------------------
__fastcall TParamsForm::~TParamsForm()
{
    FreeDBmp(&Image);
}
//---------------------------------------------------------------------------
void __fastcall TParamsForm::DoAction()
{
    // dimensions de la slection en cours
    try
    {
        BeginFilter("Modification de la slection en cours",true);
        // rcupre la slection en cours
        CheckPluginFunc(GetSelBitmap(&Image));
        // applique le filtre
        for(int i=0;i<Image.piHeight;i++)
        {
            char *Buffer=(char*)GetScanLineDBmp(&Image, i);
            for(int j=0;j<Image.piWidth;j++)
            {
                *(Buffer++)=GetBValue(PnlColor->Color);
                *(Buffer++)=GetGValue(PnlColor->Color);
                *(Buffer++)=GetRValue(PnlColor->Color);
            }
        }

        // remplace la slection et effectue la semi-trransparence
        CheckPluginFunc(SetSelBitmap(&Image,soAuto) && SetAlphaBlend(TrbAlpha->Position));
    }
    __finally
    {
        EndFilter();
    }
}
//---------------------------------------------------------------------------
void __fastcall TParamsForm::BtnOkClick(TObject *Sender)
{
    DoAction();
    DialogResult=true;
    Close();
}
//---------------------------------------------------------------------------
void __fastcall TParamsForm::BtnCancelClick(TObject *Sender)
{
    Close();
}
//---------------------------------------------------------------------------
// Actions via le clavier (KeyPreview  True)
void __fastcall TParamsForm::FormKeyPress(TObject *Sender, char &Key)
{
    if (Key==27)
    {
        Close();
    }
    else if (Key==13)
    {
        BtnOkClick(Sender);
    }
}
//---------------------------------------------------------------------------
