// Interface oriente C/C++ pour le dveloppement de plugin pour PhotoFiltre
// Version 1.0 / Avril 2004 / Copyright Benjamin FOURNIER
// Base sur la version Delphi 1.4 / Avril 2004 / Copyright Antonio Da Cruz
// La structure TPlgImage est propose par PF
// Merci de ne pas modifier les sources sans mon autorisation !

#include "Plugin.h"

char *PluginErrorMsg = "Erreur pendant l'excution du module !";

// rcupration de la langue en cours
// ----------------------------------

char *GetLanguageCode(char Code[3])
{
  Code[0] = PluginLanguage.Code[0];
  Code[1] = PluginLanguage.Code[1];
  Code[2] = 0;
  return Code;
}

char *GetLanguageStr()
{
  return PluginLanguage.Language;
}

// initialisation de l'entte
// --------------------------

void SetHeaderCaption(char *Caption)
{
  strncpy(PluginHeader.Caption, Caption, MaxShortStr);
}

void SetHeaderVersion(char *Version)
{
  strncpy(PluginHeader.Version, Version, MaxShortStr);
}

void SetHeaderPluginType(TPluginType PluginType)
{
  int Flags[] = {PT_FILTER, PT_IMAGE, PT_FILE_IMPORT, PT_FILE_EXPORT, PT_TOOL};

  PluginHeader.PluginType = Flags[PluginType];
}

void SetHeaderAuthor(char *Author)
{
  strncpy(PluginHeader.Author, Author, MaxShortStr);
}

void SetHeaderComment(char *Comment)
{
  strncpy(PluginHeader.Comment, Comment, MaxLongStr);
}

void SetHeaderMenuOptions(TMenuOption Options)
{
  PluginHeader.Flags |= Options;
}

// ces fonctions sont  utiliser uniquement dans la fonction Execute
//------------------------------------------------------------------

HWND MainHandle()
{
  return PluginStruct.MainHandle;
}

BOOL ImageExists()
{
  return PluginStruct.ImageExists;
}

BOOL IsSelected()
{
  return PluginStruct.Selected;
}

RECT GetSelRect()
{
  return PluginStruct.SelRect;
}

int GetSelWidth()
{
  return PluginStruct.SelRect.right - PluginStruct.SelRect.left;
}

int GetSelHeight()
{
  return PluginStruct.SelRect.bottom - PluginStruct.SelRect.top;
}

RECT GetImgRect()
{
  return PluginStruct.ImgRect;
}

int GetImgWidth()
{
  return PluginStruct.ImgRect.right - PluginStruct.ImgRect.left;
}

int GetImgHeight()
{
  return PluginStruct.ImgRect.bottom - PluginStruct.ImgRect.top;
}

BOOL XP_ThemesEnabled()
{
  return PluginStruct.XP_ThemesEnabled;
}

void BeginFilter(char *Msg, BOOL ChangeCursor)
{
  PluginStruct.BeginFilter(Msg, ChangeCursor);
}

void EndFilter()
{
  PluginStruct.EndFilter();
}

BOOL GetBitmap(PPlgImage pImg)
{
  return PluginStruct.GetBitmap(pImg->piBitmap);
}

BOOL SetBitmap(PPlgImage pImg)
{
  return PluginStruct.SetBitmap(pImg->piBitmap);
}

BOOL RestoreUndoBitmap()
{
  return PluginStruct.SetBitmap(NULL);
}

BOOL GetSelBitmap(PPlgImage pImg)
{
  return PluginStruct.GetSelBitmap(pImg->piBitmap);
}

BOOL SetSelBitmap(PPlgImage pImg, TSelectionOption Option)
{
  int Flags[] = {SF_AUTO, SF_NONE};

  return PluginStruct.SetSelBitmap(pImg->piBitmap, Flags[Option]);
}

TDColor GetTransparentColor()
{
  return PluginStruct.GetTransparentColor();
}

BOOL SetTransparentColor(TDColor Color)
{
  return PluginStruct.SetTransparentColor(Color);
}

int GetColorCount()
{
  return PluginStruct.GetColorCount();
}

int SetColorCount(int ColorCount)
{
  return PluginStruct.SetColorCount(ColorCount);
}

BOOL NewImage(PPlgImage pImg, char *FileName, TImageOption Option,
  int ColorCount, TDColor TransColor)
{
  int Flags[] = {IF_CREATE, IF_FILE};

  return PluginStruct.NewImage(pImg->piBitmap, FileName, Flags[Option],
    ColorCount, TransColor);
}

void ShowForm(TDForm* Form, TDialogOption Option, BOOL MainFormCenter,
  BOOL CloseWaiting)
{
  // non utilis en C++ (compatibilit de niveau 2)
}

BOOL SetAlphaBlend(TAlphaRange Alpha)
{
  return PluginStruct.SetAlphaBlend(Alpha);
}

BOOL DrawSelBorder(int Width, TDColor Color, BOOL Antialias)
{
  return PluginStruct.DrawSelBorder(Width, Color, Antialias);
}

BOOL GetSelMask(PPlgImage pImg)
{
  return PluginStruct.GetSelMask(pImg->piBitmap);
}

void ResetSaveMenu()
{
  PluginStruct.ResetSaveMenu();
}

char *GetImgFileName(char Buffer[MaxLongStr + 1])
{
  return PluginStruct.GetImgFileName(Buffer, MaxLongStr);
}

char *GetExePath(char Buffer[MaxLongStr + 1])
{
  return PluginStruct.GetExePath(Buffer, MaxLongStr);
}

char *GetOpenPath(char Buffer[MaxLongStr + 1])
{
  return PluginStruct.GetOpenPath(Buffer, MaxLongStr);
}

char *GetSavePath(char Buffer[MaxLongStr + 1])
{
  return PluginStruct.GetSavePath(Buffer, MaxLongStr);
}

char *GetPluginPath(char Buffer[MaxLongStr + 1])
{
  return PluginStruct.GetPluginPath(Buffer, MaxLongStr);
}

char *GetIniFile(char Buffer[MaxLongStr + 1])
{
  return PluginStruct.GetIniFile(Buffer, MaxLongStr);
}

BOOL SetImgFileName(char *FileName)
{
  return PluginStruct.SetImgFileName(FileName);
}

BOOL GetBitmapByName(PPlgImage pImg, char *FileName)
{
  return PluginStruct.GetBitmapByName(pImg->piBitmap, FileName);
}

BOOL GetThumb(PPlgImage pImg, TDColor BkColor, int BorderSize, int ShadowSize,
  TDColor ShadowBkColor, RECT *R)
{
  return PluginStruct.GetThumb(pImg->piBitmap, BkColor, BorderSize,
    ShadowSize, ShadowBkColor, R);
}

BOOL GetThumbByName(PPlgImage pImg, char *FileName, TDColor BkColor,
  int BorderSize, int ShadowSize, TDColor ShadowBkColor, RECT *R)
{
  return PluginStruct.GetThumbByName(pImg->piBitmap, FileName, BkColor,
    BorderSize, ShadowSize, ShadowBkColor, R);
}

BOOL EnumImages(TEnumImageProc EnumImageProc)
{
  return PluginStruct.EnumImages(EnumImageProc);
}

// plus pratique que EnumImages
// ----------------------------

char _FileName[MaxLongStr + 1];
TImageInfos *_PImageInfos;
BOOL _ImageFinded;

BOOL __stdcall _EnumImageProc(char *pFileName, int Width, int Height,
  int NbColors, TDColor TransColor)
{
  if (strcmp(pFileName, _FileName) == 0)
  {
    _ImageFinded = TRUE;
    strncpy(_PImageInfos->FileName, pFileName, MaxLongStr);
    _PImageInfos->Width = Width;
    _PImageInfos->Height = Height;
    _PImageInfos->ColorCount = NbColors;
    _PImageInfos->TransparentColor = TransColor;
  }
  return TRUE;
}

BOOL GetImgInfosByName(char *FileName, TImageInfos *ImageInfos)
{
  _ImageFinded = FALSE;
  strncpy(_FileName, FileName, MaxLongStr);
  _PImageInfos = ImageInfos;
  return EnumImages(_EnumImageProc) && _ImageFinded;
}

// compatibilit de niveau >= 2
// ----------------------------

void PrepareDialog(HWND Handle, TDialogOption Option, BOOL MainFormCenter,
  BOOL CloseWaiting)
{
  int Flags[] = {DM_MODAL, DM_PREVIEW, DM_COLOR_PICKER};

  PluginStruct.PrepareDialog(Handle, Flags[Option], MainFormCenter,
    CloseWaiting);
}

BOOL CreateDBmp(PPlgImage pImg)
{
  return PluginStruct.CreateDBmp(pImg) != 0;
}

BOOL FreeDBmp(PPlgImage pImg)
{
  return PluginStruct.FreeDBmp(pImg) != 0;
}

BOOL ReleaseHandleDBmp(PPlgImage pImg)
{
  return PluginStruct.ReleaseHandleDBmp(pImg) != 0;
}

void *GetScanLineDBmp(PPlgImage pImg, int Row)
{
  return PluginStruct.GetScanlineDBmp(pImg, Row);
}

// gestion des exceptions (non implment)
// ---------------------------------------

BOOL CheckPluginFunc(BOOL RetVal)
{
  return RetVal;
}

void ShowPluginErrorMsg()
{
  MessageBox(NULL, PluginErrorMsg, "PhotoFiltre", MB_OK | MB_ICONERROR);
}

TPluginLanguage PluginLanguage;
TPluginHeader PluginHeader;
TPluginStruct PluginStruct;
